<?php

namespace DataView;

class Tarif {
  
  

  
  

    // --- Statische Methoden ---
  
  public static function renderScript() { 
    
    
    // --- BLOCK: main ---
    
								\FOP\I18n::ensureIsLoaded();
								?>
								<script type="text/javascript">
									
									
									function updateNumbertarif(col) {
										//var checklist = window.DataViewChecked['tarif'][col];
										//if (checklist.id) {
											// checklist is online
											// TODO: check if cache is alive, otherwise reload from ajax, delay execution and return now
											//checklist.ranges = [[1,10000000]]; // mostly we use indirect idlists to tick all marks; so this is an approximation
										//}
										// checkboxes aktualisieren
										if (window.DataViewChecked && window.DataViewChecked['tarif'] && window.DataViewChecked['tarif'][col].ranges.length > 0) {
											$('.tarif__mass-action').css('visibility', 'visible');
											$('.tarif__action').css('visibility', 'hidden');
										} else {
											$('.tarif__mass-action').css('visibility', 'hidden');
											$('.tarif__action').css('visibility', 'visible');
										}
										$('.tarif__checkbox').each(function (idx, x) {
											for (var cssclass of x.classList) {
												if (cssclass.startsWith('tarif__checkbox-'+col+'-')) {
													var my_id = cssclass.substr(('tarif__checkbox-'+col+'-').length);
													if (window.DataViewChecked) {
														x.MaterialCheckbox[checklist.has(my_id) ? 'check' : 'uncheck']();
													}
												}
											}
										});
									}
									function reloadtarif (params, returnUrl, onlyScroll, addPadding = 0) {
										// copy query
										let nq = JSON.parse(JSON.stringify(query));
										nq['parent_request'] = <?php echo json_encode(strtok(\FOP\Util::getBackUrl(), '?')); ?>;
										<?php if (isset($_GET['select'])) { ?>nq['select'] = 'select';<?php } ?>
										
										if (params) {
											for (var i in params) nq[i] = params[i];
											var action = nq['action'];
											delete nq['action'];
											let querystr = "DataView/Tarif/" + action + "?" + Object.keys(nq).map(function(k){ return k + "=" +  encodeURIComponent(nq[k]); }).join("&");
											// direkt aufrufen (ist wohl ein Download oder so)
											if (returnUrl) return querystr;
											window.location.href = querystr;
										} else {
											let querystr;
											
											
											<?php if (((\FOP\User::getBuchhaltung())) && (!\FOP\User::getIsGuest())) { ?>
											delete nq['action'];
											querystr = "DataView/Tarif/renderTabTable?" + Object.keys(nq).map(function(k){ return k + "=" +  encodeURIComponent(nq[k]); }).join("&");
											// per Ajax laden
											if(!$("#tarif-table")?.parent()?.parent()?.hasClass('fop-form-feature-collapsed') || $("#tarif-table")?.parent()?.parent()?.hasClass('fop-form-feature-mode-area')) {
											$.get(querystr, function(data){
												var tab = $("#tarif-table");
												var top = tab.find('.fop-table-body-inner');
												var el;
												if (onlyScroll && (el = $('<div class="tabcontent">' + data + '</div>').find('.fop-table-body-inner'))) {
													// nur Scroll-Bereich ersetzen
													var paddingTop = parseInt(el.css('paddingTop') || '0px', 10);
													var minHeight = parseInt(el.css('minHeight'), 10)
													paddingTop += addPadding;
													minHeight += addPadding;
													top.css({paddingTop: paddingTop.toString()+'px', minHeight: minHeight.toString()+'px'}); // Offset
													el = el.children();
													top.empty();
													top.append(el);
													el = top; // top-upgrade doppelt machen, dadurch vermeiden wir das Array-upgrade => Performance
												} else {
													// gesamten Tab ersetzen
													tab.children().remove();
													el = tab.html('<div class="tabcontent">' + data + '</div>');
												}
												try {
													for (var i = 0; i < el.length; i++) upgradeDOM(el[i]);
												} catch (e) {
													console.log(e);
												}
												upgradeTable(el.find('.fop-table .fop-table-header')); // Falls es Tabellen-Layout ist: Spalten-Order anpassen
												flushURL(); // Neue URL in Titelleiste eintragen

												// Checkbox-Auswahl ankreuzen
												updateNumbertarif('ID');
											});
											} else {
												// gesamten Tab ersetzen
												var tab = $("#tarif-table");
												tab.children().remove();
												el = tab.html('<div class="fop-lazy-reload" onclick="reloadtarif()"></div>');
											}
											<?php } ?>
											
										}
									}
									function checktarif (id, col, checked) {
										// ID-Liste aufbauen
										if (!window.DataViewChecked) window.DataViewChecked = {};
										if (!window.DataViewChecked['tarif']) window.DataViewChecked['tarif'] = {};
										if (!window.DataViewChecked['tarif'][col]) window.DataViewChecked['tarif'][col] = new IDList();

										// Abfrage aller gecheckten IDs für eine Tabelle
										if (!id) {
											return window.DataViewChecked['tarif'][col].toString();
										}

										// check all, check id
										if (id == 'all') {
											// TODO: umbauen #1289: 'all' auch nur auf ne idlist reduzieren
											if (checked) {
												$.get(reloadtarif({action: 'getids', col: col}, true), function (ids) {
													window.DataViewChecked['tarif'][col] = new IDList(ids);
													updateNumbertarif(col);
												});
											} else {
												window.DataViewChecked['tarif'][col] = new IDList();
												updateNumbertarif(col);
											}
										} else {
											var ids = new IDList(id);
											var allcb = $('#tarif__all-checkbox');
											if (allcb[0]) {
												allcb[0].parentElement.MaterialCheckbox.uncheck(); // TODO: prüfen, ob Gruppen-CBs voll werden
											}
											if (checked == 'set') {
												window.DataViewChecked['tarif'][col] = ids;
											} else for (id of ids.all()) {
												if (checked) {
													window.DataViewChecked['tarif'][col].push(id);
												} else {
													window.DataViewChecked['tarif'][col].remove(id);
												}
											}
											updateNumbertarif(col);
										}
									}
								</script><?php

    
  }

  public static function renderSpecialFilters() { 
    
    
    // --- BLOCK: main ---
    ?>
	
	<script type"text/javascript">
		function updateSpecialFilter(param, val) {
			query[param] = val.toString();reloadtarif();
			
		}

	</script>
	<?php
	
    
  }

  public static function renderTabTableAction() { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
     ?><div class='fop-dv-buttonbar'><?php if(((\FOP\User::getBuchhaltung()))) { ?><a class="mdl-button mdl-js-button mdl-button--raised mdl-button--colored" onclick="
		var self = this;
		event.preventDefault();
		$.get(reloadtarif({action: 'open', fop_table: 'tarif', fop_id: '_', fop_from: location.href}, true))
		.then(function () {
			window.open_url(self.href, false);
		});" href="<?php echo htmlentities(\TablesRouter\Tarif::createURL2(['from' => $_GET['from'] ?? null, 'popup' => $_GET['popup'] ?? null])); ?>"><i class="material-icons">add</i> <?php echo(sprintf(_('create %s'), _('Beitrags-Tarif'))); ?></a><?php } ?></div><?php 
								\FOP\User::getIsGuest();
								$itemheight = 32;
								$itemsperpage = ceil(1080 / $itemheight * 0.8);
								$page = (isset($_GET['page_tarif']) ? intval($_GET['page_tarif']) : 0);
								$addlines = (isset($_GET['addlines_tarif']) ? intval($_GET['addlines_tarif']) : 0);
								$firstitem = $page * $itemsperpage;
								$sqladdon = ' LIMIT ' . ($itemsperpage * 2) . ' OFFSET ' . ($firstitem);
								$data = self::getData($sqladdon, $_GET);
								$arr = $data["items"];
								$itemcount = $data["itemcount"];
								$lastPage = ceil($itemcount/$itemsperpage-1);
								// calculate width of first column: 67px + 32px for each shortcut
								$firstColumnWidth = 66 + 34 + 34 + 34;
								$additionalLines = 0;

									// Spaltenliste zuerst aufbauen, damit sie noch umsortiert werden kann
									$order = 1000;
									$columns = [];
									
										if(true){
											$col = [
												'id' => 'name',
												'desc' => _('Bezeichnung'),
												'order' => ++$order,
												'width' => 180, // default value
												'collapsed' => 0

											];
											$columns['name'] = $col;
										}
									
										if(true){
											$col = [
												'id' => 'amount',
												'desc' => _('Beitragshöhe / Monat'),
												'order' => ++$order,
												'width' => 120, // default value
												'collapsed' => 0

											];
											$columns['amount'] = $col;
										}
									

									// gespeicherte Spaltenanordnung
									foreach (\FOP\Database::query('SELECT * FROM fop_dataview WHERE '.qi('user').' = ' . \FOP\Database::quote(\FOP\User::getID()) . ' AND dataview = ' . \FOP\Database::quote('tarif'))->fetchAll(\PDO::FETCH_ASSOC) AS $column => $c) {
										if (isset($columns[$c['column']])) {
											$columns[$c['column']]['order'] = $c['order']; // order, width, collapsed
											$columns[$c['column']]['width'] = $c['width']; // order, width, collapsed
											$columns[$c['column']]['collapsed'] = $c['collapsed']; // order, width, collapsed
										}
									}

									// DOM vor-rendern
									
										
										if(true){
											ob_start();
											?><div class="fop-table-column overlay"
												data-column='name'
												data-order='<?php echo intval($columns['name']['order']); ?>'
												data-width='<?php echo intval($columns['name']['width']); ?>'
												data-collapsed='<?php echo intval($columns['name']['collapsed']); ?>'
												style='width: <?php echo intval($columns['name']['width']); ?>px; <?php if ($columns['name']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
												<span class='title' onclick="
		var changed = false, win = dropDownFixPosition($(this), null, function() { if (changed) {
			
			reloadtarif(); 
		}});
		
		var el = $('<div class=\'mdl-textfield mdl-js-textfield mdl-textfield--floating-label fop-floatsorter\' style=\'width: calc(100% - 42px);\'><input class=\'mdl-textfield__input\' style=\'display: inline-block;\' type=\'text\'><label class=\'mdl-textfield__input\'><?php echo(_('search')); ?></label></div>');
		win.append(el);
		var text = el.find('input');
		text.val(query['search_tarif_name'])
		text.on('change keyup paste', function () { if (text.val()) { query['search_tarif_name'] = text.val(); } else { delete query['search_tarif_name']; } changed = true; });
		text.focus();
		text.select();
		text.keydown(function (event) {if ((event.keyCode || event.which) == 13) {$('#table_tarif').find('.fop-table-row:first').click();} if (event.key === 'Escape') { win.close(); }});

		var el2 = $('<div class=\'mdl-textfield mdl-js-textfield mdl-textfield--floating-label\'><input class=\'mdl-textfield__input\' style=\'display: inline-block;\' type=\'text\'><label class=\'mdl-textfield__input\'><?php echo(htmlentities(htmlentities(_('filter_contains_not')))); ?></label></div>');
		win.append(el2);
		var text2 = el2.find('input');
		text2.val(query['searchnot_tarif_name'])
		text2.on('change keyup paste', function () { if (text2.val()) { query['searchnot_tarif_name'] = text2.val(); } else { delete query['searchnot_tarif_name']; } changed = true; });
		text2.keydown(function (event) {if ((event.keyCode || event.which) == 13) {$('#table_tarif').find('.fop-table-row:first').click();} if (event.key === 'Escape') { win.close(); }});
	
	var icon, sortbtn	= $('<a class=\'mdl-button mdl-js-button mdl-button--icon mdl-button--colored\' style=\'display: inline-block;\'></a>')
		.append(icon = $('<i class=\'material-icons\'></i>').text('unfold_more'))
		.click(function() {
		 if (query['sort_tarif'] == 'name ASC') {
			query['sort_tarif'] = 'name DESC';
		 } else if (query['sort_tarif'] == 'name DESC') {
		 	delete query['sort_tarif'];
		 } else {
			query['sort_tarif'] = 'name ASC';
		 }
		 reloadtarif();
		 return false;
	});
	if (win.children().first().hasClass('fop-floatsorter')) {
		// floating layout
		win.prepend(sortbtn.css({float: 'right', margin: '0px'}));
	} else {
		// append to the end
		win.append(sortbtn);
	}
		return false;
	">
													<span class='title-title' title='<?php echo(_('Bezeichnung')); ?>'><?php echo(_('Bezeichnung')); ?></span>
													<?php // sort indicator
														if (isset($_GET['sort_tarif']) && $_GET['sort_tarif'] == 'name ASC') {
															?><i class='material-icons fop-small'>keyboard_arrow_down</i><?php
														} else if (isset($_GET['sort_tarif']) && $_GET['sort_tarif'] == 'name DESC') {
															?><i class='material-icons fop-small'>keyboard_arrow_up</i><?php
														}
														if (isset($_GET['range_min_tarif_name']) || isset($_GET['range_max_tarif_name']) || isset($_GET['deps_tarif_name']) || isset($_GET['fullsearch_tarif_name']) || isset($_GET['dynamic_tarif_name']) || isset($_GET['search_tarif_name']) || isset($_GET['searchnot_tarif_name']) || isset($_GET['filter_tarif_name'])) {
															// filter indicator
															?><i class='material-icons fop-small'>filter_list</i><?php
														}
														// search indicator
														?><i class='material-icons fop-small'>search</i>
													</span>
												<div class='fop-column-handle'></div>
											</div><?php
											$columns['name']['header'] = ob_get_contents(); ob_end_clean();
											$columns['name']['render'] = function ($item) use (&$columns, $itemheight) {
												// Render-Callback für eine Zelle
												?><div class='fop-table-column'
													style='width: <?php echo intval($columns['name']['width']); ?>px; <?php if ($columns['name']['collapsed'] == 1) { echo ' display: none;'; } ?> height: <?php echo $itemheight; ?>px; ' data-column='name'><span class='overflow-text' title="<?php echo htmlentities($item['name']); ?>"><?php echo htmlentities($item['name']); ?></span></div><?php
											};
											$columns['name']['renderSum'] = function ($item) use (&$columns) {
												// Render-Callback Summe
												?><div class='fop-table-column fop-table-column-aggregate'
													data-column='name'
													data-order='<?php echo intval($columns['name']['order']); ?>'
													data-width='<?php echo intval($columns['name']['width']); ?>'
													data-collapsed='<?php echo intval($columns['name']['collapsed']); ?>'
													style='width: <?php echo intval($columns['name']['width']); ?>px; <?php if ($columns['name']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
													</div><?php
											};
										}
										
									
										
										if(true){
											ob_start();
											?><div class="fop-table-column overlay"
												data-column='amount'
												data-order='<?php echo intval($columns['amount']['order']); ?>'
												data-width='<?php echo intval($columns['amount']['width']); ?>'
												data-collapsed='<?php echo intval($columns['amount']['collapsed']); ?>'
												style='width: <?php echo intval($columns['amount']['width']); ?>px; <?php if ($columns['amount']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
												<span class='title' onclick="
		var changed = false, win = dropDownFixPosition($(this), null, function() { if (changed) {
			
			reloadtarif(); 
		}});
		var von, bis; win.append('<div class=\'fop-floatsorter\'>' + window.i18n_von + '</div>').append(von = $('<input type=\'number\' step=\'any\'><br>').val(query['range_min_tarif_amount']).on('change keyup paste', function () { query['range_min_tarif_amount'] = von.val(); delete query['page_tarif']; changed = true; }))
.append('<div>' + window.i18n_bis + '</div>').append(bis = $('<input type=\'number\' step=\'any\'>').val(query['range_max_tarif_amount']).on('change keyup paste', function () { query['range_max_tarif_amount'] = bis.val(); delete query['page_tarif']; changed = true; }))
; von.focus(); von.select();
	var icon, sortbtn	= $('<a class=\'mdl-button mdl-js-button mdl-button--icon mdl-button--colored\' style=\'display: inline-block;\'></a>')
		.append(icon = $('<i class=\'material-icons\'></i>').text('unfold_more'))
		.click(function() {
		 if (query['sort_tarif'] == 'amount ASC') {
			query['sort_tarif'] = 'amount DESC';
		 } else if (query['sort_tarif'] == 'amount DESC') {
		 	delete query['sort_tarif'];
		 } else {
			query['sort_tarif'] = 'amount ASC';
		 }
		 reloadtarif();
		 return false;
	});
	if (win.children().first().hasClass('fop-floatsorter')) {
		// floating layout
		win.prepend(sortbtn.css({float: 'right', margin: '0px'}));
	} else {
		// append to the end
		win.append(sortbtn);
	}
		return false;
	" style='text-align: right;'>
													<span class='title-title' title='<?php echo(_('Beitragshöhe / Monat')); ?>'><?php echo(_('Beitragshöhe / Monat')); ?></span>
													<?php // sort indicator
														if (isset($_GET['sort_tarif']) && $_GET['sort_tarif'] == 'amount ASC') {
															?><i class='material-icons fop-small'>keyboard_arrow_down</i><?php
														} else if (isset($_GET['sort_tarif']) && $_GET['sort_tarif'] == 'amount DESC') {
															?><i class='material-icons fop-small'>keyboard_arrow_up</i><?php
														}
														if (isset($_GET['range_min_tarif_amount']) || isset($_GET['range_max_tarif_amount']) || isset($_GET['deps_tarif_amount']) || isset($_GET['fullsearch_tarif_amount']) || isset($_GET['dynamic_tarif_amount']) || isset($_GET['search_tarif_amount']) || isset($_GET['searchnot_tarif_amount']) || isset($_GET['filter_tarif_amount'])) {
															// filter indicator
															?><i class='material-icons fop-small'>filter_list</i><?php
														}
														// search indicator
														?><i class='material-icons fop-small'>search</i>
													</span>
												<div class='fop-column-handle'></div>
											</div><?php
											$columns['amount']['header'] = ob_get_contents(); ob_end_clean();
											$columns['amount']['render'] = function ($item) use (&$columns, $itemheight) {
												// Render-Callback für eine Zelle
												?><div class='fop-table-column'
													style='width: <?php echo intval($columns['amount']['width']); ?>px; <?php if ($columns['amount']['collapsed'] == 1) { echo ' display: none;'; } ?> height: <?php echo $itemheight; ?>px; ' data-column='amount'><span style="white-space: nowrap; width: 100%; display: inline-block; text-align: right;"><?php echo htmlentities(\Types\Euro::print($item['amount'])); ?><?php echo '&nbsp;' .  htmlentities('€'); ?>
	</span></div><?php
											};
											$columns['amount']['renderSum'] = function ($item) use (&$columns) {
												// Render-Callback Summe
												?><div class='fop-table-column fop-table-column-aggregate'
													data-column='amount'
													data-order='<?php echo intval($columns['amount']['order']); ?>'
													data-width='<?php echo intval($columns['amount']['width']); ?>'
													data-collapsed='<?php echo intval($columns['amount']['collapsed']); ?>'
													style='width: <?php echo intval($columns['amount']['width']); ?>px; <?php if ($columns['amount']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
													</div><?php
											};
										}
										
									

									// sort by order
									uasort($columns, function ($a, $b) {
										return $a['order'] - $b['order'];
									});
									?>
									<style type='text/css'>
										#tarif-table .fop-table-header {
											height: <?php echo 32; ?>px;
										}
										#tarif-table .fop-table-header .fop-table-column .title,
										#tarif-table .fop-column-handle,
										#tarif-table .fop-table-row,
										#tarif-table .fop-table-row .fop-table-column,
										#tarif-table .fop-table-column-multicontrol,
										#tarif-table .fop-filter-button {
											height: 32px;
											line-height: 32px;
										}
										</style>
											<div class="fop-table" data-table-id="tarif">
											<div class="fop-legend"></div>
											<div class="fop-filter-string-wrapper"><div class="fop-filter-string"><label>Filter:</label> <span><?php echo self::getFilterHTML($_GET); ?></span></div></div>
											
											<?php if (isset($_GET['select'])) { echo '<br>'; } ?>
											<div class="fop-table-header">
											<?php if (!isset($_GET['select'])) { ?>
												<div class="fop-table-column noprint" style="width: <?php echo json_encode($firstColumnWidth); ?>px;">
													
													<div class="fop-table-column-multicontrol">
													<label class="mdl-checkbox mdl-js-checkbox"  style='width: auto;' for="tarif__all-checkbox">
														<input class="mdl-checkbox__input" id="tarif__all-checkbox" type="checkbox" onchange="checktarif('all', 'ID', this.checked);">
														</label>
														<button type="button" class="mdl-button mdl-js-button mdl-button--icon tarif__mass-action" style='visibility: hidden;' onclick="$.get('DataView/Tarif/permissions?id=' + checktarif(null, 'ID'), function (data) { for (var method in data) if (method != '__cnt') { var btn = $('[data-interaction-name=&quot;' + method + '&quot;]'); if (data[method] >= 1) btn.show(); else btn.hide(); btn.find('.cnt').text(data[method]); }; }); dropDownFixPosition($(this), $(this).next())">
															<i class="material-icons">more_vert</i>
														</button>
														<ul class="mdl-list mdl-card mdl-shadow--4dp fop-scroll-menu">
															<?php
		if(true) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="filterall" style="margin-right:auto; text-align:left;"
					onclick="for (key in query) if (key.indexOf('range_min_tarif_') == 0 || key.indexOf('range_max_tarif_') == 0 || key.indexOf('deps_tarif_') == 0 || key.indexOf('fullsearch_tarif_') == 0 || key.indexOf('dynamic_tarif_') == 0 || key.indexOf('search_tarif_') == 0 || key.indexOf('searchnot_tarif_') == 0 || key.indexOf('filter_tarif_') == 0) delete query[key]; reloadtarif(); $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">list</i></span><span class="fop-menu-caption" title="<?php echo(_('view all elements')); ?>"><?php echo(_('view all elements')); ?> 
					</span>
				</span>
			</span>
		<?php } ?><?php
		if(true) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="filteronly" style="margin-right:auto; text-align:left;"
					onclick="query['filter_tarif_ID'] = checktarif(null, 'ID'); delete query['page_tarif']; reloadtarif(); $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">arrow_forward</i></span><span class="fop-menu-caption" title="<?php echo(_('view only these elements')); ?>"><?php echo(_('view only these elements')); ?> (<span class='cnt'></span>)
					</span>
				</span>
			</span>
		<?php } ?><?php
		if(true) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="filterrange" style="margin-right:auto; text-align:left;"
					onclick="
		var ticks = new IDList(checktarif(null, 'ID'));
		var range = prompt('Bitte geben Sie den Bereich ein', '1-' + ticks.count());
		var newticks = new IDList();
		if (range) {
			range = range.split('-');
			if (range.length == 1) {
				range.push(range[0]);
			}
			var skip = (range[0] || 1) - 1;
			var take = (range[1] || Infinity) - skip;
			for (var item of ticks.all()) {
				if (skip > 0) {
					skip--;
				} else if (take > 0) {
					newticks.push(item);
					take--;
				} else break;
			}
			checktarif(newticks, 'ID', 'set');
		} $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">colorize</i></span><span class="fop-menu-caption" title="<?php echo(_('limit range')); ?>"><?php echo(_('limit range')); ?> (<span class='cnt'></span>)
					</span>
				</span>
			</span>
		<?php } ?><?php
		if(true && ((\FOP\User::getBuchhaltung()))) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="delete" style="margin-right:auto; text-align:left;"
					onclick="if(!confirm(<?php echo htmlentities(json_encode(_('confirmdelete'))); ?>)) return;$.get('Tables/Tarif/delete?ajax&from=<?php echo urlencode(\FOP\Util::getBackUrl()); ?>&id=' + escape(checktarif(null, 'ID'))).then(function () { reloadtarif(); }, function (err) { if (err.responseText.startsWith('http')) { window.location.href = err.responseText; } else {alert(err.responseText); }}); $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">delete</i></span><span class="fop-menu-caption" title="<?php echo(_('delete')); ?>"><?php echo(_('delete')); ?> (<span class='cnt'></span>)
					</span>
				</span>
			</span>
		<?php } ?>
														</ul>
														<!-- column hide -->
														<button type="button" class="mdl-button mdl-js-button mdl-button--icon" onclick="dropDownFixPosition($(this), $(this).next())">
															<i class="material-icons">visibility</i>
														</button>
														<ul class="mdl-list mdl-card mdl-shadow--4dp fop-scroll-menu">
															<?php foreach ($columns AS $col) { ?>
																<li class="mdl-list__item mdl-button" onclick="
																	var isVisible = this.firstElementChild.innerText !== 'clear';
																	this.firstElementChild.innerText = isVisible ? 'clear' : 'visibility'; // switch icon
																	tableColumnVisibility('tarif', <?php echo htmlentities(json_encode($col['id'])); ?>, !isVisible); // the rest is up to a helper function in layout/tables.fop
																	">
																	<i class="material-icons"><?php if ($col['collapsed']) { echo 'clear'; } else { echo 'visibility'; }?></i>
																	<?php echo htmlentities($col['desc']); ?>
																</li>
															<?php } ?>
															<li class="mdl-list__item mdl-button" onclick="
																$.get('FOP/Index/dataview?data='+encodeURIComponent(JSON.stringify({dataview: 'tarif', reset: true}))).then(function () { location.reload(); });
																">
																<i class="material-icons">refresh</i>
																<?php echo _('reset all'); ?>
															</li>
														</ul>
													</div>
												</div><?php }
												
												foreach ($columns AS $col) {
													// Spalten-Überschrift rendern
													echo $col['header'];
												} ?>
											 </div>
											
											<div class="fop-table-body" id="table_tarif" <?php \EasyEditor\Navigation::printScroll('dv.Tarif', '/* scroll horiz */ this.previousElementSibling.firstElementChild.style.marginLeft = \'-\' + this.scrollLeft + \'px\';
												/* scroll verti */
												var self = this;
												if (window.DataViewScrollReloadTimeout) clearTimeout(window.DataViewScrollReloadTimeout);
												window.DataViewScrollReloadTimeout = setTimeout(function () {
													var currentPage = parseInt(query[\'page_tarif\'] || 0);
													var paddingTop = parseInt( self.lastElementChild.style.paddingTop, 10);
													var wantedPage = Math.max(0, currentPage + Math.floor((self.scrollTop - paddingTop) / ' . ($itemheight * $itemsperpage) . '));
													if (wantedPage != currentPage) {
														query[\'page_tarif\'] = wantedPage;
														reloadtarif(undefined, undefined, true);
													}
												}, 50);
											'); ?>>
												<div class="fop-table-body-inner" style="min-height: <?php echo 12 + $itemheight * ($itemcount + $additionalLines); ?>px; padding-top: <?php echo $itemheight * $itemsperpage * $page; ?>px;">
												<?php foreach($arr as $itempos => $item) {
													?>
													<div class="fop-table-row" style=""data-itempos="<?php echo htmlentities($item['sortableOrder']); ?>" data-tarif-id="<?php echo htmlentities($item['ID']); ?>"<?php if (isset($item['ID'])){
														if (isset($_GET['select']) && isset($_GET['from'])) {
															echo 'onclick="event.preventDefault(); if (!window.getSelection().toString()) window.location.href=' . htmlentities(json_encode($_GET['from'] . '&colvalue=' . urlencode($item['ID']))) . ';" ';
														} else {
															echo 'onclick="event.preventDefault(); if (!window.getSelection().toString()) open_url(reloadtarif({action: \'open\', fop_table: \'tarif\', fop_id: ' .  htmlentities(json_encode($item['ID'])) . ', fop_from: location.href}, true), false);"';
														}
													}?> >

													<?php if (!isset($_GET['select'])) { ?>
													<div class='fop-table-column noprint' style="width: <?php echo json_encode($firstColumnWidth); ?>px;" onclick="$(this).find('input[type=checkbox]').first().click(); event.stopPropagation();">
													<label onclick="event.stopPropagation();" class="mdl-checkbox mdl-js-checkbox tarif__checkbox tarif__checkbox tarif__checkbox-ID-<?php echo htmlentities($item['ID']); ?>" style="width: auto;" for="tarif__<?php echo htmlentities($itempos); ?>-checkbox">
													<input class="mdl-checkbox__input" id="tarif__<?php echo htmlentities($itempos); ?>-checkbox" type="checkbox" onchange="<?php if (isset($item['ID'])) echo 'checktarif(' . htmlentities(json_encode($item['ID'])) . ', \'ID\', this.checked); ' ?>">
													</label><?php if(!isset($item['canSort']) || $item['canSort']) {
														?><a title="<?php echo htmlentities(_('sort')); ?>" class="sorthandle mdl-button mdl-js-button mdl-button--icon" onclick="event.stopPropagation();"><i class="material-icons">swap_vert</i></a><?php
													} ?><button type="button" class="mdl-button mdl-js-button mdl-button--icon tarif__action" onclick="
														event.stopPropagation();
														dropDownFixPosition($(this), $(this).next());
														">
														<i class="material-icons">more_vert</i>
													</button><ul class="mdl-list mdl-card mdl-shadow--4dp fop-scroll-menu" id="fop-scroll-menu-tarif-action-<?php echo $item['ID'] ?? 0; ?>">
														<?php
		if(isset($item['ID']) && $item['operation::view']) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="view" style="margin-right:auto; text-align:left;" href="<?php echo htmlentities(\TablesRouter\Tarif::viewURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick=" if (!event.ctrlKey) { open_url(reloadtarif({action: 'open', fop_table: 'tarif', fop_id: <?php echo htmlentities(json_encode($item['ID'])); ?>, fop_from: location.href}, true), false); return false; } $(this).closest('.overlay').click(); return false;  
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">find_in_page</i></span><span class="fop-menu-caption" title="<?php echo(_('open')); ?>"><?php echo(_('open')); ?></span>
			</a>
		<?php } ?><?php
		if(isset($item['ID']) && $item['operation::view'] && $item['operation::edit']) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="edit" style="margin-right:auto; text-align:left;" href="<?php echo htmlentities(\TablesRouter\Tarif::editURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="   
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">edit</i></span><span class="fop-menu-caption" title="<?php echo(_('edit')); ?>"><?php echo(_('edit')); ?></span>
			</a>
		<?php } ?><?php
		if(isset($item['ID']) && ((false))) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="create_tarifDynamicMonthyear_dynamic:parent" style="margin-right:auto; text-align:left;" href="<?php echo htmlentities(\TablesRouter\TarifDynamicMonthyear::createURL2(['column_dynamic:parent' => $item['ID'], 'from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="   
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">create</i></span><span class="fop-menu-caption" title="<?php echo(sprintf(_('create %s'), sprintf(_('versions of %s'), _('Beitrags-Tarif')))); ?>"><?php echo(sprintf(_('create %s'), sprintf(_('versions of %s'), _('Beitrags-Tarif')))); ?></span>
			</a>
		<?php } ?><?php
		if(isset($item['ID']) && $item['operation::delete']) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="delete" style="margin-right:auto; text-align:left;" href="#"
				onclick="if(!confirm(<?php echo htmlentities(json_encode(_('confirmdelete'))); ?>)) return false;   $.get('Tables/Tarif/delete?ajax&id=<?php echo htmlentities($item['ID']);?>&from=<?php echo htmlentities(\FOP\Util::getBackUrl());?>').then(function () { reloadtarif(); }, function (err) { if (err.responseText.startsWith('http')) { window.location.href = err.responseText; } else {alert(err.responseText); }}); $(this).closest('.overlay').click(); return false;
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">delete</i></span><span class="fop-menu-caption" title="<?php echo(_('delete')); ?>"><?php echo(_('delete')); ?></span>
			</a>
		<?php } ?>
													</ul><?php
		if(isset($item['ID']) && $item['operation::view'] && $item['operation::edit']) {
			?><a class="mdl-button mdl-js-button mdl-button--icon tbl-link" data-tbl="tarif" data-id="<?php echo htmlentities($item['ID']); ?>" data-interaction-name="edit" href="<?php echo htmlentities(\TablesRouter\Tarif::editURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="event.stopPropagation();    reloadtarif();
					$(this).closest('.overlay').click();
					if (this.href != '#') {
						open_url(this.href, false);
					}
					event.preventDefault();"
				title="<?php echo(_('edit')); ?>">
				<i class="material-icons">edit</i>
			</a><?php } ?><?php
		if(isset($item['ID']) && $item['operation::view']) {
			?><a class="mdl-button mdl-js-button mdl-button--icon tbl-link" data-tbl="tarif" data-id="<?php echo htmlentities($item['ID']); ?>" data-interaction-name="view" href="<?php echo htmlentities(\TablesRouter\Tarif::viewURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="event.stopPropagation();  if (!event.ctrlKey) { open_url(reloadtarif({action: 'open', fop_table: 'tarif', fop_id: <?php echo htmlentities(json_encode($item['ID'])); ?>, fop_from: location.href}, true), false); return false; }  reloadtarif();
					$(this).closest('.overlay').click();
					if (this.href != '#') {
						open_url(this.href, false);
					}
					event.preventDefault();"
				title="<?php echo(_('open')); ?>">
				<i class="material-icons">find_in_page</i>
			</a><?php } ?>
													</div><?php } ?><?php
													
													foreach ($columns AS $col) {
														$col['render']($item);
													}
													?></div>
												 <?php }?>

													</div>
												</div>

												
												
												<script src='js/jquery.ui.touch-punch.min.js'></script>
												<script type="text/javascript">
												$(function(){
													$("#table_tarif .fop-table-body-inner").sortable({
														'cursor': 'move',
														'handle': '.sorthandle',
														'start': function (event, ui) {
														},
														'update': function (event, ui) {
															var newids = $("#table_tarif .fop-table-body-inner").sortable("toArray", {"attribute": "data-tarif-id"});
															var positions = $("#table_tarif .fop-table-body-inner").sortable("toArray", {"attribute": "data-itempos"}).map(function (x) {
																if (!x || x == 0) {
																	// nullen sanitizen
																	x = Math.round(Math.random() * 2000000) + 100;
																}
																return x;
															});
															positions.sort(function (a, b) {
																return Number(a) - Number(b);
															}); // sortieren, damit die neue Reihenfolge funzt
															var changedpos = {};
															for(var i = 0; i < newids.length; i++){
																changedpos[newids[i]] = positions[i]; 
															}
															
															$.get(reloadtarif({action: "sort", data: JSON.stringify(changedpos)}, true), function(response){
																// OK
															});
														}
													});
												});
												</script>
												
												</div><?php
												
	
    
  }

  public static function getidsAction($col) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
			$q = \FOP\Database::query('SELECT t.'.qi($col).' '.self::getSQL($_GET));
			$result = new \FOP\IDList();
			while ($item = $q->fetchColumn()) {
				$result->push($item);
			}
			die($result->toString());

    
  }

  public static function permissionsAction($id) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
		$ids = new \FOP\IDList($id);
		header('Content-Type: application/json');
		
		$perms = \FOP\Database::query('SELECT COUNT(*) AS __cnt, SUM(CASE (TRUE) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('filteronly').', SUM(CASE (TRUE) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('filterrange').', SUM(CASE (TRUE) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('filterall').', SUM(CASE (('.\FOP\Database::quote(\FOP\User::getBuchhaltung()).')) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('delete').' FROM '.qi('tarif').' WHERE ' . $ids->toSQL(qi('ID')))->fetch(\PDO::FETCH_ASSOC);
		
		return $perms;
	
    
  }

  public static function sortAction($data) { 
    
    
    // --- BLOCK: access ---
    if(!(((\FOP\User::getBuchhaltung())) && (!\FOP\User::getIsGuest()))) throw new \FOP\AccessDeniedException();
    // --- BLOCK: main ---
    
		if ($data == '*') {
			// Position aus sord_tarif ziehen
			$q = self::getData(' LIMIT 1024', $_GET, true);
			$order = 1;
			$s = [];
			foreach ($q AS $item) {
				array_push($s, 'WHEN ' . intval($item['ID']) . ' THEN ' . intval($order++));
			}
		} else {
			// Position von Elementen als JSON aus $data ziehen
			$newpos = json_decode($data, true);

			$s = array_map(function($value, $key){
				return 'WHEN ' . intval($key) . ' THEN ' . intval($value);
			}, array_values($newpos), array_keys($newpos));
		}

		// Zugriffsregel: sort
		$sql = 'UPDATE '.qi('tarif').' SET '.qi('sortableOrder').' = (CASE '.qi('ID').' ' . implode(' ', $s) . ' ELSE '.qi('sortableOrder').' END) WHERE ('.(\FOP\User::getIsGuest() ? 'false' : 'true').')';

		\FOP\Database::query($sql);

		
	
    
  }

  public static function getSQL($params) { 
    
    
    // --- BLOCK: dependency-tarif ---
    
		if (isset($params['select']) && $params['select'] == 'tarif') {
			$deps = [];
		}
	
    // --- BLOCK: dependency-tarifNull ---
    
		if (isset($params['select']) && $params['select'] == 'tarifNull') {
			$deps = [];
		}
	
    // --- BLOCK: dependency-tarifNullBuchung ---
    
		if (isset($params['select']) && $params['select'] == 'tarifNullBuchung') {
			$deps = [];
		}
	
    // --- BLOCK: main ---
    
								// returns a sql snippet 'FROM (...) AS t WHERE' where you can prepend your select clauses and append your ORDER LIMIT
								$sql = 'FROM (SELECT /* ID */ '.qi('ID').' AS '.qi('ID').',
									/* amount */ (SELECT ('.qi('xXvyFbpv').'.'.qi('amount').') FROM '.qi('tarifDynamicMonthyear').' '.qi('xXvyFbpv').' WHERE '.qi('xXvyFbpv').'.'.qi('dynamic:parent').' = '.qi('tarif').'.'.qi('ID').' AND (('.qi('xXvyFbpv').'.'.qi('dynamic:time').') <= (' . \FOP\Database::sessionVarSQL('time') . ')) ORDER BY '.qi('xXvyFbpv').'.'.qi('dynamic:time').' DESC LIMIT 1) AS '.qi('amount').',
									/* canSort */ '.(\FOP\User::getIsGuest() ? 'false' : 'true').' AS '.qi('canSort').',
									/* name */ '.qi('name').' AS '.qi('name').',
									/* operation::create */ ('.\FOP\Database::quote(\FOP\User::getBuchhaltung()).') AS '.qi('operation::create').',
									/* operation::delete */ ('.\FOP\Database::quote(\FOP\User::getBuchhaltung()).') AS '.qi('operation::delete').',
									/* operation::edit */ ('.\FOP\Database::quote(\FOP\User::getBuchhaltung()).') AS '.qi('operation::edit').',
									/* operation::index */ ' . (!\FOP\User::getIsGuest() ? 1 : 0) . ' AS '.qi('operation::index').',
									/* operation::view */ ('.\FOP\Database::quote(\FOP\User::getBuchhaltung()).') AS '.qi('operation::view').',
									/* sortableOrder */ '.qi('sortableOrder').' AS '.qi('sortableOrder').',
									1
								FROM '.qi('tarif').' '.qi('tarif').'
								WHERE ((('.\FOP\Database::quote(\FOP\User::getBuchhaltung()).')))
									AND (' . (isset($_GET['select']) && $_GET['select'] == 'tarif' ? 'TRUE' : 'TRUE') . ')
									AND (' . (isset($_GET['select']) && $_GET['select'] == 'tarifNull' ? 'TRUE' : 'TRUE') . ')
									AND (' . (isset($_GET['select']) && $_GET['select'] == 'tarifNullBuchung' ? 'TRUE' : 'TRUE') . ')) AS t
								WHERE ' . (isset($params['range_min_tarif_amount']) ? ($params['range_min_tarif_amount'] !== '' && is_numeric($params['range_min_tarif_amount']) ? 't.'.qi('amount').' >= ' . \FOP\Database::quote($params['range_min_tarif_amount']) . ' AND ' : '') : '') . 
								(isset($params['range_max_tarif_amount']) ? ($params['range_max_tarif_amount'] !== '' && is_numeric($params['range_max_tarif_amount']) ? 't.'.qi('amount').' <= ' . \FOP\Database::quote($params['range_max_tarif_amount']) . ' AND ' : '') : '') . 
								(isset($params['filter_tarif_name']) ? ($params['filter_tarif_name'] !== '' ? ('(' . (new \FOP\IDList($params['filter_tarif_name']))->toSQL('t.'.qi('name').'') . ') AND ') : '') : '') . 
								(isset($params['filter_tarif_amount']) ? ($params['filter_tarif_amount'] !== '' ? ('(' . (new \FOP\IDList($params['filter_tarif_amount']))->toSQL('t.'.qi('amount').'') . ') AND ') : '') : '') . 
								(isset($params['filter_tarif_ID']) ? ($params['filter_tarif_ID'] !== '' ? ('(' . (new \FOP\IDList($params['filter_tarif_ID']))->toSQL('t.'.qi('ID').'') . ') AND ') : '') : '') . 
								(isset($params['search_tarif_name']) ? 't.'.qi('name').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['search_tarif_name'] . '%') . ' AND ' : '') . 
								(isset($params['searchnot_tarif_name']) ? 'NOT t.'.qi('name').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['searchnot_tarif_name'] . '%') . ' AND ' : '') . 
								(isset($params['search_tarif']) ? '(' . 't.'.qi('name').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['search_tarif'] . '%') . ') AND ' : '') . 
								'
								 TRUE ';
								return $sql;
	
    
  }

  public static function getData($sqladdon, $params, $stream = false ) { 
    
    
    // --- BLOCK: main ---
    
								$sql = self::getSQL($params);

								$order = (\FOP\Util::array_value(array(
									'name ASC' => 'ORDER BY t.'.qi('name').' ASC',
									'amount ASC' => 'ORDER BY t.'.qi('amount').' ASC',
									'name DESC' => 'ORDER BY t.'.qi('name').' DESC',
									'amount DESC' => 'ORDER BY t.'.qi('amount').' DESC',
									'' => ''), isset($params['sort_tarif']) ? $params['sort_tarif'] : '') ?: 'ORDER BY '.qi('t').'.'.qi('sortableOrder').' ');
								// wenn sqladdon bereits ein ORDER enthält, kein order aufbauen
								if (strpos($sqladdon, 'ORDER') !== false) {
									$order = '';
								}
								if ($stream) {
									// als Stream (währenddessen darf keine weitere SQL-Query laufen) für große Datenmengen und Statistiken
									$result = (function () use ($sql, $order, $sqladdon) {
										$stream = \FOP\Database::query('SELECT t.* ' . $sql . $order . $sqladdon);
										while ($item = $stream->fetch(\PDO::FETCH_ASSOC)) {
											$item['amount'] = \Types\Euro::unpack($item['amount']);
											
											yield $item;
										}
									})();
								} else {
									// als RAM-Array
									$result = \FOP\Database::query('SELECT t.* ' . $sql . $order . $sqladdon);
									$arr = $result->fetchAll(\PDO::FETCH_ASSOC);
									$itemcount = count($arr);

									foreach($arr as $i => &$item){
										$item['amount'] = \Types\Euro::unpack($item['amount']);
										
									}
									unset($item);

									$result = ["items" => $arr, "itemcount" => $itemcount];

									
								}

								return $result;
	
    
  }

  public static function getFilterHTML($params, $delimiter = ', ' , $showButton = true ) { 
    
    
    // --- BLOCK: main ---
    
		// Contract: ist showButton == false, sollten keine HTML-Tags im Output enthalten sein (Verwendung in Dateinamen!!)
		$filters = [];
		
	if (isset($params['range_min_tarif_amount']) && isset($params['range_max_tarif_amount'])) {
		array_push($filters, _('Beitragshöhe / Monat') . ': ' . (\Types\Euro::print($params['range_min_tarif_amount']) .  ' €'
	) . ' ' . _('filters_between') . ' ' . (\Types\Euro::print($params['range_max_tarif_amount']) .  ' €'
	));
	} else if (isset($params['range_min_tarif_amount'])) {
		array_push($filters, _('Beitragshöhe / Monat') . ': ' . _('filters_from') . ' ' . (\Types\Euro::print($params['range_min_tarif_amount']) .  ' €'
	));
	} else if (isset($params['range_max_tarif_amount'])) {
		array_push($filters, _('Beitragshöhe / Monat') . ': ' . _('filters_to') . ' ' . (\Types\Euro::print($params['range_max_tarif_amount']) .  ' €'
	));
	}if (isset($params['filter_tarif_name'])) {
		if ($params['filter_tarif_name'] == '_null') {
			array_push($filters, _('Bezeichnung') . ': ' . 'NULL');
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_tarif_name']))->all() AS $val) {
				$value = $val;
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('Bezeichnung') . ': ' . implode(', ', $values));
		}
	}if (isset($params['filter_tarif_amount'])) {
		if ($params['filter_tarif_amount'] == '_null') {
			array_push($filters, _('Beitragshöhe / Monat') . ': ' . 'NULL');
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_tarif_amount']))->all() AS $val) {
				$value = \Types\Euro::print($val) .  ' €'
	;
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('Beitragshöhe / Monat') . ': ' . implode(', ', $values));
		}
	}if (isset($params['search_tarif_name'])) {
		array_push($filters, _('name') . ' ' . _('filter_contains') . ' ' . $params['search_tarif_name']);
	}if (isset($params['searchnot_tarif_name'])) {
		array_push($filters, _('name') . ' ' . _('filter_contains_not') . ' ' . $params['searchnot_tarif_name']);
	}
		if (isset($params['sort_tarif']) && $showButton) {
			array_push($filters, [htmlentities(_('sort order')), ' <i class="material-icons fop-small" style="cursor: pointer;" onclick="$.get(reloadtarif({action: &apos;sort&apos;, data: &apos;*&apos;}, true)).then(function () { delete query[&apos;sort_tarif&apos;]; reloadtarif();  });">💾</i>']);
		}
	
		if (count($filters)) {
			$result = implode($delimiter, array_map(function ($filter) {
				if (is_array($filter)) {
					return implode('', $filter);
				}
				return htmlentities($filter);
			}, $filters))
			// Button, um Filter zu entfernen
			. ($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="for (var q in query) {if (q.includes(\'_tarif_\')) delete query[q];} reloadtarif(); ">clear</i>' : '');
		} else {
			$result = _('no_filter');
		}
		return $result;
	
    
  }

  public static function openAction($fop_table, $fop_id, $fop_from) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    

if ($fop_table == 'tarif') {
	\FOP\Session::setPayload('dv-tarif', [
		'id' => 'tarif',
		'tbl' => 'tarif',
		'idcol' => 'ID',
		'prev' => \DataViewRouter\Tarif::stepURL('tarif', 'XXX', -1),
		'next' => \DataViewRouter\Tarif::stepURL('tarif', 'XXX',  1),
		'from' => $fop_from
	]);
	
	if ($fop_id == '_') return; // nur Rückreferenz setzen, nicht öffnen
	$params = [];
	if (isset($_GET['popup'])) $params['popup'] = true;
	if (isset($_GET['from'])) $params['from'] = $_GET['from'];
	$params['id'] = $fop_id;
	
	$url = \TablesRouter\Tarif::viewURL2($params);
	header('Location: ' . $url);
}

die();
    
  }

  public static function stepAction($tbl, $id, $step) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
	$dv = \FOP\Session::getPayload('dv-'.$tbl);
	$url = $dv['from'];
	$parts = parse_url($url);
	parse_str($parts['query'], $query);
	$data = self::getData('', $query);
	$col = $dv['idcol'];
	$ids = array_map(function ($x) use ($col) {return $x[$col];}, $data['items']);
	if (!count($ids)) {
		header('Location: ' . \FOP\Util::getCurrentBaseurl() . 'Tables/' . preg_replace('/[^a-zA-Z0-9_]/', '_', ucfirst($dv['tbl'])));
		die();
	}
	$idx = array_search($id, $ids);
	$idx += count($ids) + $step;
	$idx = $idx % count($ids);
	header('Location: ' . \FOP\Util::getCurrentBaseurl() . 'Tables/' . preg_replace('/[^a-zA-Z0-9_]/', '_', ucfirst($dv['tbl'])) . '/view?id=' . urlencode($ids[$idx]));
	die();

    
  }


  
  

  
  
}



